=== debian/changelog ===
snapcast (0.31.0-1) unstable; urgency=medium

  * New upstream release.
  * Build-depend on libjack-jackd2-dev.

 -- Felix Geyer <fgeyer@debian.org>  Mon, 03 Mar 2025 20:50:28 +0100
