=== debian/watch ===
version=4
https://github.com/badaix/snapcast/tags .*/v?([\d\.]+)\.tar\.gz
