## snapcast 0.34.0

=== debian/changelog ===
snapcast (0.34.0-2) unstable; urgency=medium

  * Enable pulse and pipewire backends. (Closes: #1126928)

 -- Felix Geyer <fgeyer@debian.org>  Sun, 08 Feb 2026 23:21:07 +0100

snapcast (0.34.0-1) unstable; urgency=medium

  * New upstream release.
  * Clean up build-dependencies.

 -- Felix Geyer <fgeyer@debian.org>  Sat, 24 Jan 2026 16:50:23 +0100
